using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace SelectPdf.Samples.Pages
{
    public class PdfSecurityModel : PageModel
    {
        public void OnGet()
        {

        }

        public IActionResult OnPost()
        {
            // create a new pdf document
            PdfDocument doc = new PdfDocument();

            // add a new page to the document
            PdfPage page = doc.AddPage();

            // create a new pdf font
            PdfFont font = doc.AddFont(PdfStandardFont.Helvetica);
            font.Size = 20;

            // create a new text element and add it to the page
            PdfTextElement text = new PdfTextElement(50, 50,
                "Pdf Security Settings Sample.", font);
            page.Add(text);

            // set document passwords
            doc.Security.OwnerPassword = "test1";
            doc.Security.UserPassword = "test2";

            //set document permissions
            doc.Security.CanAssembleDocument = false;
            doc.Security.CanCopyContent = true;
            doc.Security.CanAccessibilityCopyContent = true;
            doc.Security.CanEditAnnotations = true;
            doc.Security.CanEditContent = true;
            doc.Security.CanFillFormFields = true;
            doc.Security.CanPrint = true;

            // save pdf document
            byte[] pdf = doc.Save();

            // close pdf document
            doc.Close();

            // return resulted pdf document
            FileResult fileResult = new FileContentResult(pdf, "application/pdf");
            fileResult.FileDownloadName = "Document.pdf";
            return fileResult;

        }
    }
}